<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\LoginService;

class LoginController extends FMCrud{
    protected $LoginService;
   
    public function __construct($crudService, $environment, LoginService $LoginService) {
        parent::__construct($crudService, $environment);
        $this->LoginService = $LoginService;
    }

    public function validaLogin(DTO\Request $request, DTO\Response $response) {
      $param = $request->getParameters();
      $variavel = $this->LoginService->validaLogin($param);
      $dtsVal = new DataSet('func', $variavel);
      $response->addDataSet($dtsVal);
    }
    
    public function getUserPermiss(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $nrfuncionario = $param['nrfuncionario'];
        
        $permissArray = $this->LoginService->getUserPermiss($nrfuncionario);
        $dtsVal = new DataSet('info', $permissArray);
      
        $response->addDataSet($dtsVal);
    }
}
?>