<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ParamLeitContPessoasService;

class ParamLeitContPessoasController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $ParamLeitContPessoasService;
   
    public function __construct($crudService, $environment, ParamLeitContPessoasService $ParamLeitContPessoasService) {
        parent::__construct($crudService, $environment);
        $this->ParamLeitContPessoasService = $ParamLeitContPessoasService;
    }
    
    public function insertParamLeituras(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $value = $this->ParamLeitContPessoasService->insertParamLeituras($params);
        $var = array($value);
        $dtsVal = new DataSet('ItemID', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getParamLeituras(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $paramsLeitura = $this->ParamLeitContPessoasService->getParamLeituras($params);
        $dtsVal = new DataSet("Sensores", $paramsLeitura);
        $response->addDataSet($dtsVal);
    } 
    
    public function baseRoute(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        if ($method == "POST") {
            $this->insertParamLeituras($request, $response);
        } else if ($method == "GET") {
            $this->getParamLeituras($request, $response);
        }
    }
    
    public function updateParamLeituras(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $value = $this->ParamLeitContPessoasService->updateParamLeituras($params);
        $dtsVal = new DataSet('info',array('message' => 'Editado com sucesso'));
        $response->addDataSet($dtsVal);
    }
}

?>